<script lang="ts">
	import { run } from 'svelte/legacy';

	import { onMount } from 'svelte'
	import FitBitActivity from '../../components/FitBitActivity.svelte'
	import type { PageData } from './$types'
	import { enhance, type SubmitFunction } from '$app/forms'
	import SelectList from '../../components/SelectList.svelte'
	import Popup from '../../components/Popup.svelte'

	interface Props {
		data: PageData;
	}

	let { data }: Props = $props();
	let activities: any[] = $state(data.fromSync || [])
	let types: string[] = $state(data.fromSync?.length ? [...new Set(data.fromSync.map(o => o.type))] : [])

	let selectedTypes: string[] = $state([])
	let selectedItems: string[] = $state([])

	let showConfetti: boolean = false
	let postWorkoutsText: string = $state('No workouts selected')
	let enablePostWorkouts: boolean = $state(false)
	let enableSyncButton: boolean = $state(true)

	let showPopup = $state(false)
	let popupText: string = $state('')

  let errNoActivities: boolean = $state(false)

	let selectedActivityIds: string = $state(data.ids.filter(o => activities.find(x => x.fitbitId === o)).join(','))

	updateActivitiesById()
  
	const donger1 = '‿︵‿︵( ☆ ͜o ☆)‿︵‿︵'
	const donger2 = '︵‿︵‿(☆ ͜o ☆ )︵‿︵‿'
	let donger = $state(donger1)

	function danceyBoi() {
		let speed = 750
		let inner: NodeJS.Timer
		setIntervalAndExecute(() => {
			if (inner) {
				speed = speed > 50 ? speed - 50 : speed
				clearInterval(inner)
			}

			inner = setInterval(() => {
				if (donger === donger1) {
					donger = donger2
				} else {
					donger = donger1
				}
			}, speed)
		}, 60 * 1000)
	}

  function setIntervalAndExecute(fn: () => any, ms: number) {
		fn()
		setInterval(fn, ms)
	}

	danceyBoi()

	function updateSelectedActivitiesList(activities: any[]) {
		selectedActivityIds = activities
			.filter((o) => o.selected)
			.map((o) => o.fitbitId)
			.join(',')
	}

	function updatePostWorkoutsText() {
		const count = activities.filter((o) => o.selected).length
		enablePostWorkouts = count > 0

		const totalDistance = activities.filter((o) => o.selected).reduce((acc, obj) => acc + obj.distance, 0)
		postWorkoutsText = count === 0 ? 'No workouts selected' : `Post ${count} workouts (${Math.round(totalDistance)} km)`

		if (count > 0 && selectedItems.length === 0) {
			postWorkoutsText = 'Select some routes first!'
		}

		updateSelectedActivitiesList(activities)
		console.log(selectedActivityIds)
	}

	function updateActivitiesById() {
		const split = selectedActivityIds.split(',')
		activities = activities.map((o) => {
			o.selected = split.includes(o.fitbitId)
			return o
		})
	}

	function updateSelectedActivities() {
		activities = activities.map((o) => {
			o.selected = selectedTypes.includes(o.type)
			return o
		})
	}

	function deselectType(type: string) {
		activities.forEach((o) => {
			if (o.type === type) {
				o.selected = false
			}
		})

		activities = activities
	}

	function selectType(type: string) {
		activities.forEach((o) => {
			if (o.type === type) {
				o.selected = true
			}
		})

		activities = activities
	}

	const fitbitCallback: SubmitFunction = (input) => {
		enableSyncButton = false
    errNoActivities = false
		return async ({ result, update }) => {
			enableSyncButton = true
			activities = (result as any).data.activities
			types = (result as any).data.types
			if (!selectedTypes?.length) {
				console.log(`types is empty`)
				selectedTypes = [...new Set(types)]
				updateSelectedActivities()
			}
      if (!activities.length) {
        errNoActivities = true
      }
			await update()
		}
	}

	const postCallback: SubmitFunction = (input) => {
		return async ({ result, update }) => {
			selectedItems = []
			selectedTypes = []
			activities = []
			const message = (result as any).data.message
			const confetti = (result as any).data.confetti

			await update()
			fadePopup(message, confetti)
		}
	}

	function fadePopup(message: string, confetti = false) {
		popupText = message
		showPopup = true
		setTimeout(() => {
			showPopup = false
			window.location.href = '/'
		}, 5000)
		if (confetti) {
			showConfetti = true
			setTimeout(() => (showConfetti = false), 5000)
		}
	}
	run(() => {
		updateSelectedActivitiesList(activities)
	});
	run(() => {
		updatePostWorkoutsText(activities, selectedItems)
	});
	let hasFitbit = $derived(data.user?.fitbitAuth?.length > 0)
</script>

<div id="main">
	{#if hasFitbit}
		<div style="display: flex; flex-direction: row; gap: 1rem; justify-content: space-between">
			<form method="POST" action="?/fitbit" use:enhance={fitbitCallback}>
				<button
					class:disabled={!hasFitbit || !enableSyncButton}
					disabled={!hasFitbit || !enableSyncButton}
					name="button"
					value="test"
				>
					Sync with Fitbit
				</button>
			</form>

			<form method="POST" action="?/postFitbit" use:enhance={postCallback}>
				<input type="hidden" name="ids" value={selectedActivityIds} />
				<input type="hidden" name="routes" value={JSON.stringify(selectedItems)} />
				<button
					class:disabled={!enablePostWorkouts || !selectedItems.length}
					disabled={!enablePostWorkouts || !selectedItems.length}
					name="button"
					value="test">{postWorkoutsText}</button
				>
			</form>
		</div>

		{#if activities.length}
			<SelectList
				text=""
				name="types"
				title="Select types"
				description="Select all workouts that match types..."
				bind:selectedItems={selectedTypes}
				items={types}
				on:add={(e) => selectType(e.detail.item)}
				on:remove={(e) => deselectType(e.detail.item)}
			/>

			<SelectList
				text="View Routes..."
				name="routes"
				title="Route"
				description="Which route(s) do you want to make this progress on?"
				bind:selectedItems
				items={data.routeOptions}
			/>

			<div style="grid-row: 3">
				{#each activities as item}
					<FitBitActivity activity={item} on:click={updatePostWorkoutsText} />
				{/each}
			</div>
		{/if}
    {#if errNoActivities}
      <a href="#">Looks like there are no new activities in Fitbit yet - go get moving!</a>
      <h1>{donger}</h1>
    {/if}
	{:else}
		<a href="/settings">You don't seem to have fitbit sync set up yet - do this in Settings</a>
	{/if}
</div>

{#if showPopup}
	<Popup text={popupText} textRainbow={true} />
{/if}

<style>
	div {
		display: flex;
		flex-direction: column;
		row-gap: 1rem;
		overflow-y: scroll;
	}

	a {
		margin: 2rem;
		color: var(--accentColour);
		text-decoration: none;
	}

	#main {
		display: flex;
	}

	button {
		background-color: var(--accentColour);
		border: none;
		border-radius: 0.25rem;
		display: inline-block;
		margin: 1rem;
		font-family: Quicksand;
		font-weight: 500;
		padding-left: 1rem;
		padding-right: 1rem;
		padding-top: 0.5rem;
		padding-bottom: 0.5rem;
		font-size: 1.2rem;
	}

	button.disabled {
		color: #ffffff55;
		background-color: #ffffff05;
	}

  h1 {
		--color-background: #1b1b1b;
		--stroke-width: calc(1em / 16);
		--font-size: 32px;
		--font-weight: 700;
		--letter-spacing: calc(1em / 8);

		-webkit-background-clip: text;
		background-clip: text;
		background-image: -webkit-gradient(
			linear,
			left top,
			right top,
			from(#09f1b8),
			color-stop(#00a2ff),
			color-stop(#ff00d2),
			to(#fed90f)
		);
		background-image: -o-linear-gradient(left, #09f1b8, #00a2ff, #ff00d2, #fed90f);
		background-image: linear-gradient(to right, #09f1b8, #00a2ff, #ff00d2, #fed90f);
		color: #000119;
		color: var(--color-background);
		font-size: 30vmin;
		font-size: var(--font-size);
		font-weight: 700;
		font-weight: var(--font-weight);
		letter-spacing: calc(1em / 8);
		letter-spacing: var(--letter-spacing);
		padding: calc(--stroke-width / 2);
		-webkit-text-stroke-color: transparent;
		-webkit-text-stroke-width: calc(1em / 16);
		-webkit-text-stroke-width: var(--stroke-width);
	}
</style>
